# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from rosee_msg/GraspingAction.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import rosee_msg.msg

class GraspingAction(genpy.Message):
  _md5sum = "87996b200b19e74f79515a72e2db6744"
  _type = "rosee_msg/GraspingAction"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """## Info message, used by GraspingActionsAvailable service, which store the infos about a specific action

# action type, that is an enum and with msg we can only define it like this
# remember to add here if we add new type in Action.h and ActionPrimitive.h ..

uint8 PRIMITIVE = 0
uint8 GENERIC = 1
uint8 COMPOSED  = 2
uint8 TIMED = 3
uint8 NONE = 4
uint8 action_type

# subtype for primitive, no meaning if action_type is not 1
uint8 PRIMITIVE_PINCHTIGHT = 0
uint8 PRIMITIVE_PINCHLOOSE = 1
uint8 PRIMITIVE_MULTIPLEPINCHTIGHT = 2
uint8 PRIMITIVE_TRIG = 3
uint8 PRIMITIVE_TIPFLEX = 4
uint8 PRIMITIVE_FINGFLEX = 5
uint8 PRIMITIVE_SINGLEJOINTMULTIPLETIPS = 6
uint8 PRIMITIVE_NONE = 7
uint8 primitive_type

# name of the action
string action_name

# names of the selectable fingers/joints (eg 2 finger for pinch) if any
string[] elements_involved

# The mask which says if the motor is used by the action (count > 0) or not (count = 0). 
# It is unique for each action (differently from action_motor_positions which is a vector) 
JointsInvolvedCount action_motor_count

# actuator position associated with the action. Can be more than one for some action (like pinches and PRIMITIVE_SINGLEJOINTMULTIPLETIPS)
MotorPosition[] action_motor_positions

#used only for timed and composed
string[] inner_actions

## used only for timed.. better to make a new msg?
float64[] before_time_margins
float64[] after_time_margins


================================================================================
MSG: rosee_msg/JointsInvolvedCount
# This is the msg for the type 
#    "typedef std::map <std::string, unsigned int> JointsInvolvedCount"


# All arrays in this message should have the same size, or be empty.
# This is the only way to uniquely associate the joint name with the correct
# states. 

string[] name
uint8[] count


================================================================================
MSG: rosee_msg/MotorPosition
# I do not want to use standard joint state because also velocity and effort are present, which are not used by an action

# All arrays in this message should have the same size, or be empty.
# This is the only way to uniquely associate the joint name with the correct
# states.

string[] name
float64[] position
"""
  # Pseudo-constants
  PRIMITIVE = 0
  GENERIC = 1
  COMPOSED = 2
  TIMED = 3
  NONE = 4
  PRIMITIVE_PINCHTIGHT = 0
  PRIMITIVE_PINCHLOOSE = 1
  PRIMITIVE_MULTIPLEPINCHTIGHT = 2
  PRIMITIVE_TRIG = 3
  PRIMITIVE_TIPFLEX = 4
  PRIMITIVE_FINGFLEX = 5
  PRIMITIVE_SINGLEJOINTMULTIPLETIPS = 6
  PRIMITIVE_NONE = 7

  __slots__ = ['action_type','primitive_type','action_name','elements_involved','action_motor_count','action_motor_positions','inner_actions','before_time_margins','after_time_margins']
  _slot_types = ['uint8','uint8','string','string[]','rosee_msg/JointsInvolvedCount','rosee_msg/MotorPosition[]','string[]','float64[]','float64[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       action_type,primitive_type,action_name,elements_involved,action_motor_count,action_motor_positions,inner_actions,before_time_margins,after_time_margins

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(GraspingAction, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.action_type is None:
        self.action_type = 0
      if self.primitive_type is None:
        self.primitive_type = 0
      if self.action_name is None:
        self.action_name = ''
      if self.elements_involved is None:
        self.elements_involved = []
      if self.action_motor_count is None:
        self.action_motor_count = rosee_msg.msg.JointsInvolvedCount()
      if self.action_motor_positions is None:
        self.action_motor_positions = []
      if self.inner_actions is None:
        self.inner_actions = []
      if self.before_time_margins is None:
        self.before_time_margins = []
      if self.after_time_margins is None:
        self.after_time_margins = []
    else:
      self.action_type = 0
      self.primitive_type = 0
      self.action_name = ''
      self.elements_involved = []
      self.action_motor_count = rosee_msg.msg.JointsInvolvedCount()
      self.action_motor_positions = []
      self.inner_actions = []
      self.before_time_margins = []
      self.after_time_margins = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_2B().pack(_x.action_type, _x.primitive_type))
      _x = self.action_name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.elements_involved)
      buff.write(_struct_I.pack(length))
      for val1 in self.elements_involved:
        length = len(val1)
        if python3 or type(val1) == unicode:
          val1 = val1.encode('utf-8')
          length = len(val1)
        buff.write(struct.Struct('<I%ss'%length).pack(length, val1))
      length = len(self.action_motor_count.name)
      buff.write(_struct_I.pack(length))
      for val1 in self.action_motor_count.name:
        length = len(val1)
        if python3 or type(val1) == unicode:
          val1 = val1.encode('utf-8')
          length = len(val1)
        buff.write(struct.Struct('<I%ss'%length).pack(length, val1))
      _x = self.action_motor_count.count
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.action_motor_positions)
      buff.write(_struct_I.pack(length))
      for val1 in self.action_motor_positions:
        length = len(val1.name)
        buff.write(_struct_I.pack(length))
        for val2 in val1.name:
          length = len(val2)
          if python3 or type(val2) == unicode:
            val2 = val2.encode('utf-8')
            length = len(val2)
          buff.write(struct.Struct('<I%ss'%length).pack(length, val2))
        length = len(val1.position)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(struct.Struct(pattern).pack(*val1.position))
      length = len(self.inner_actions)
      buff.write(_struct_I.pack(length))
      for val1 in self.inner_actions:
        length = len(val1)
        if python3 or type(val1) == unicode:
          val1 = val1.encode('utf-8')
          length = len(val1)
        buff.write(struct.Struct('<I%ss'%length).pack(length, val1))
      length = len(self.before_time_margins)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(struct.Struct(pattern).pack(*self.before_time_margins))
      length = len(self.after_time_margins)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(struct.Struct(pattern).pack(*self.after_time_margins))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.action_motor_count is None:
        self.action_motor_count = rosee_msg.msg.JointsInvolvedCount()
      if self.action_motor_positions is None:
        self.action_motor_positions = None
      end = 0
      _x = self
      start = end
      end += 2
      (_x.action_type, _x.primitive_type,) = _get_struct_2B().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action_name = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.action_name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.elements_involved = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1 = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1 = str[start:end]
        self.elements_involved.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.action_motor_count.name = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1 = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1 = str[start:end]
        self.action_motor_count.name.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.action_motor_count.count = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.action_motor_positions = []
      for i in range(0, length):
        val1 = rosee_msg.msg.MotorPosition()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.name = []
        for i in range(0, length):
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2 = str[start:end].decode('utf-8', 'rosmsg')
          else:
            val2 = str[start:end]
          val1.name.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        s = struct.Struct(pattern)
        end += s.size
        val1.position = s.unpack(str[start:end])
        self.action_motor_positions.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.inner_actions = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1 = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1 = str[start:end]
        self.inner_actions.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.before_time_margins = s.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.after_time_margins = s.unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_2B().pack(_x.action_type, _x.primitive_type))
      _x = self.action_name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.elements_involved)
      buff.write(_struct_I.pack(length))
      for val1 in self.elements_involved:
        length = len(val1)
        if python3 or type(val1) == unicode:
          val1 = val1.encode('utf-8')
          length = len(val1)
        buff.write(struct.Struct('<I%ss'%length).pack(length, val1))
      length = len(self.action_motor_count.name)
      buff.write(_struct_I.pack(length))
      for val1 in self.action_motor_count.name:
        length = len(val1)
        if python3 or type(val1) == unicode:
          val1 = val1.encode('utf-8')
          length = len(val1)
        buff.write(struct.Struct('<I%ss'%length).pack(length, val1))
      _x = self.action_motor_count.count
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.action_motor_positions)
      buff.write(_struct_I.pack(length))
      for val1 in self.action_motor_positions:
        length = len(val1.name)
        buff.write(_struct_I.pack(length))
        for val2 in val1.name:
          length = len(val2)
          if python3 or type(val2) == unicode:
            val2 = val2.encode('utf-8')
            length = len(val2)
          buff.write(struct.Struct('<I%ss'%length).pack(length, val2))
        length = len(val1.position)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(val1.position.tostring())
      length = len(self.inner_actions)
      buff.write(_struct_I.pack(length))
      for val1 in self.inner_actions:
        length = len(val1)
        if python3 or type(val1) == unicode:
          val1 = val1.encode('utf-8')
          length = len(val1)
        buff.write(struct.Struct('<I%ss'%length).pack(length, val1))
      length = len(self.before_time_margins)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(self.before_time_margins.tostring())
      length = len(self.after_time_margins)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(self.after_time_margins.tostring())
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.action_motor_count is None:
        self.action_motor_count = rosee_msg.msg.JointsInvolvedCount()
      if self.action_motor_positions is None:
        self.action_motor_positions = None
      end = 0
      _x = self
      start = end
      end += 2
      (_x.action_type, _x.primitive_type,) = _get_struct_2B().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action_name = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.action_name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.elements_involved = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1 = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1 = str[start:end]
        self.elements_involved.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.action_motor_count.name = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1 = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1 = str[start:end]
        self.action_motor_count.name.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.action_motor_count.count = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.action_motor_positions = []
      for i in range(0, length):
        val1 = rosee_msg.msg.MotorPosition()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.name = []
        for i in range(0, length):
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2 = str[start:end].decode('utf-8', 'rosmsg')
          else:
            val2 = str[start:end]
          val1.name.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        s = struct.Struct(pattern)
        end += s.size
        val1.position = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
        self.action_motor_positions.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.inner_actions = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1 = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1 = str[start:end]
        self.inner_actions.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.before_time_margins = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.after_time_margins = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2B = None
def _get_struct_2B():
    global _struct_2B
    if _struct_2B is None:
        _struct_2B = struct.Struct("<2B")
    return _struct_2B
