# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from rosee_msg/ROSEEActionControl.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import genpy

class ROSEEActionControl(genpy.Message):
  _md5sum = "951124e492d9f0c612d1b821a37e6001"
  _type = "rosee_msg/ROSEEActionControl"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq

#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp

# first finger to use to pinch
string action_name

# action type, that is an enum and with msg we can only define it like this
# remember to add here if we add new type in Action.h and ActionPrimitive.h ..
uint8 PRIMITIVE = 0
uint8 GENERIC = 1 
uint8 COMPOSED = 2 
uint8 TIMED = 3
uint8 NONE = 4
uint8 action_type

uint8 PRIMITIVE_PINCHSTRONG = 0
uint8 PRIMITIVE_PINCHWEAK = 1
uint8 PRIMITIVE_MULTIPLEPINCHSTRONG = 2
uint8 PRIMITIVE_TRIG = 3
uint8 PRIMITIVE_TIPFLEX = 4
uint8 PRIMITIVE_FINGFLEX = 5
uint8 PRIMITIVE_SINGLEJOINTMULTIPLETIPS = 6
uint8 PRIMITIVE_NONE = 7
uint8 actionPrimitive_type

# array for additional items (like 2 finger for pinch). It can be also empty 
string[] selectable_items

# grasp percentage from 0.0 to 1.0
float64 percentage

# wanted maximum error norm for joints positions error (if not set, ie it is 0, default one will be used)
# the action will not be considered completed until the norm error of joint pos is below this value
float64 error_norm

#Optional fields, since now we use them to send also a current/torque to heri ii
string[] optional_motors_names
float64[] optional_motors_commands
"""
  # Pseudo-constants
  PRIMITIVE = 0
  GENERIC = 1
  COMPOSED = 2
  TIMED = 3
  NONE = 4
  PRIMITIVE_PINCHSTRONG = 0
  PRIMITIVE_PINCHWEAK = 1
  PRIMITIVE_MULTIPLEPINCHSTRONG = 2
  PRIMITIVE_TRIG = 3
  PRIMITIVE_TIPFLEX = 4
  PRIMITIVE_FINGFLEX = 5
  PRIMITIVE_SINGLEJOINTMULTIPLETIPS = 6
  PRIMITIVE_NONE = 7

  __slots__ = ['seq','stamp','action_name','action_type','actionPrimitive_type','selectable_items','percentage','error_norm','optional_motors_names','optional_motors_commands']
  _slot_types = ['uint32','time','string','uint8','uint8','string[]','float64','float64','string[]','float64[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       seq,stamp,action_name,action_type,actionPrimitive_type,selectable_items,percentage,error_norm,optional_motors_names,optional_motors_commands

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(ROSEEActionControl, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.seq is None:
        self.seq = 0
      if self.stamp is None:
        self.stamp = genpy.Time()
      if self.action_name is None:
        self.action_name = ''
      if self.action_type is None:
        self.action_type = 0
      if self.actionPrimitive_type is None:
        self.actionPrimitive_type = 0
      if self.selectable_items is None:
        self.selectable_items = []
      if self.percentage is None:
        self.percentage = 0.
      if self.error_norm is None:
        self.error_norm = 0.
      if self.optional_motors_names is None:
        self.optional_motors_names = []
      if self.optional_motors_commands is None:
        self.optional_motors_commands = []
    else:
      self.seq = 0
      self.stamp = genpy.Time()
      self.action_name = ''
      self.action_type = 0
      self.actionPrimitive_type = 0
      self.selectable_items = []
      self.percentage = 0.
      self.error_norm = 0.
      self.optional_motors_names = []
      self.optional_motors_commands = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.seq, _x.stamp.secs, _x.stamp.nsecs))
      _x = self.action_name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_2B().pack(_x.action_type, _x.actionPrimitive_type))
      length = len(self.selectable_items)
      buff.write(_struct_I.pack(length))
      for val1 in self.selectable_items:
        length = len(val1)
        if python3 or type(val1) == unicode:
          val1 = val1.encode('utf-8')
          length = len(val1)
        buff.write(struct.Struct('<I%ss'%length).pack(length, val1))
      _x = self
      buff.write(_get_struct_2d().pack(_x.percentage, _x.error_norm))
      length = len(self.optional_motors_names)
      buff.write(_struct_I.pack(length))
      for val1 in self.optional_motors_names:
        length = len(val1)
        if python3 or type(val1) == unicode:
          val1 = val1.encode('utf-8')
          length = len(val1)
        buff.write(struct.Struct('<I%ss'%length).pack(length, val1))
      length = len(self.optional_motors_commands)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(struct.Struct(pattern).pack(*self.optional_motors_commands))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.stamp is None:
        self.stamp = genpy.Time()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.seq, _x.stamp.secs, _x.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action_name = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.action_name = str[start:end]
      _x = self
      start = end
      end += 2
      (_x.action_type, _x.actionPrimitive_type,) = _get_struct_2B().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.selectable_items = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1 = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1 = str[start:end]
        self.selectable_items.append(val1)
      _x = self
      start = end
      end += 16
      (_x.percentage, _x.error_norm,) = _get_struct_2d().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.optional_motors_names = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1 = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1 = str[start:end]
        self.optional_motors_names.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.optional_motors_commands = s.unpack(str[start:end])
      self.stamp.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.seq, _x.stamp.secs, _x.stamp.nsecs))
      _x = self.action_name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_2B().pack(_x.action_type, _x.actionPrimitive_type))
      length = len(self.selectable_items)
      buff.write(_struct_I.pack(length))
      for val1 in self.selectable_items:
        length = len(val1)
        if python3 or type(val1) == unicode:
          val1 = val1.encode('utf-8')
          length = len(val1)
        buff.write(struct.Struct('<I%ss'%length).pack(length, val1))
      _x = self
      buff.write(_get_struct_2d().pack(_x.percentage, _x.error_norm))
      length = len(self.optional_motors_names)
      buff.write(_struct_I.pack(length))
      for val1 in self.optional_motors_names:
        length = len(val1)
        if python3 or type(val1) == unicode:
          val1 = val1.encode('utf-8')
          length = len(val1)
        buff.write(struct.Struct('<I%ss'%length).pack(length, val1))
      length = len(self.optional_motors_commands)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(self.optional_motors_commands.tostring())
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.stamp is None:
        self.stamp = genpy.Time()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.seq, _x.stamp.secs, _x.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action_name = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.action_name = str[start:end]
      _x = self
      start = end
      end += 2
      (_x.action_type, _x.actionPrimitive_type,) = _get_struct_2B().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.selectable_items = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1 = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1 = str[start:end]
        self.selectable_items.append(val1)
      _x = self
      start = end
      end += 16
      (_x.percentage, _x.error_norm,) = _get_struct_2d().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.optional_motors_names = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1 = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1 = str[start:end]
        self.optional_motors_names.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.optional_motors_commands = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      self.stamp.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2B = None
def _get_struct_2B():
    global _struct_2B
    if _struct_2B is None:
        _struct_2B = struct.Struct("<2B")
    return _struct_2B
_struct_2d = None
def _get_struct_2d():
    global _struct_2d
    if _struct_2d is None:
        _struct_2d = struct.Struct("<2d")
    return _struct_2d
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
