# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from rosee_msg/NewGenericGraspingActionSrvRequest.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import rosee_msg.msg

class NewGenericGraspingActionSrvRequest(genpy.Message):
  _md5sum = "5c8aaa1397a9c435f368f25efcaf70fe"
  _type = "rosee_msg/NewGenericGraspingActionSrvRequest"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """## Service associated with GenericGraspingAction message

NewGenericGraspingAction newAction

# user can also request to store the action in a yaml file, togheter with the others
bool emitYaml


================================================================================
MSG: rosee_msg/NewGenericGraspingAction
# Message which include all the infos necessary to insert a new action in the system 
# (https://github.com/ADVRHumanoids/ROSEndEffector/issues/71)

# name of the action
string action_name

# Motor Position
MotorPosition action_motor_position

# OPTIONAL The mask which says if the motor is used by the action (count > 0) or not (count = 0).
# take care that if it is not included, the not used joint will be considered the ones with 0 position
JointsInvolvedCount action_motor_count
                                  
# OPTIONAL field to indicate which hand element will be moved by the action
string[] elements_involved

================================================================================
MSG: rosee_msg/MotorPosition
# I do not want to use standard joint state because also velocity and effort are present, which are not used by an action

# All arrays in this message should have the same size, or be empty.
# This is the only way to uniquely associate the joint name with the correct
# states.

string[] name
float64[] position

================================================================================
MSG: rosee_msg/JointsInvolvedCount
# This is the msg for the type 
#    "typedef std::map <std::string, unsigned int> JointsInvolvedCount"


# All arrays in this message should have the same size, or be empty.
# This is the only way to uniquely associate the joint name with the correct
# states. 

string[] name
uint8[] count

"""
  __slots__ = ['newAction','emitYaml']
  _slot_types = ['rosee_msg/NewGenericGraspingAction','bool']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       newAction,emitYaml

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(NewGenericGraspingActionSrvRequest, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.newAction is None:
        self.newAction = rosee_msg.msg.NewGenericGraspingAction()
      if self.emitYaml is None:
        self.emitYaml = False
    else:
      self.newAction = rosee_msg.msg.NewGenericGraspingAction()
      self.emitYaml = False

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.newAction.action_name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.newAction.action_motor_position.name)
      buff.write(_struct_I.pack(length))
      for val1 in self.newAction.action_motor_position.name:
        length = len(val1)
        if python3 or type(val1) == unicode:
          val1 = val1.encode('utf-8')
          length = len(val1)
        buff.write(struct.Struct('<I%ss'%length).pack(length, val1))
      length = len(self.newAction.action_motor_position.position)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(struct.Struct(pattern).pack(*self.newAction.action_motor_position.position))
      length = len(self.newAction.action_motor_count.name)
      buff.write(_struct_I.pack(length))
      for val1 in self.newAction.action_motor_count.name:
        length = len(val1)
        if python3 or type(val1) == unicode:
          val1 = val1.encode('utf-8')
          length = len(val1)
        buff.write(struct.Struct('<I%ss'%length).pack(length, val1))
      _x = self.newAction.action_motor_count.count
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.newAction.elements_involved)
      buff.write(_struct_I.pack(length))
      for val1 in self.newAction.elements_involved:
        length = len(val1)
        if python3 or type(val1) == unicode:
          val1 = val1.encode('utf-8')
          length = len(val1)
        buff.write(struct.Struct('<I%ss'%length).pack(length, val1))
      _x = self.emitYaml
      buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.newAction is None:
        self.newAction = rosee_msg.msg.NewGenericGraspingAction()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.newAction.action_name = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.newAction.action_name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.newAction.action_motor_position.name = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1 = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1 = str[start:end]
        self.newAction.action_motor_position.name.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.newAction.action_motor_position.position = s.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.newAction.action_motor_count.name = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1 = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1 = str[start:end]
        self.newAction.action_motor_count.name.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.newAction.action_motor_count.count = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.newAction.elements_involved = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1 = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1 = str[start:end]
        self.newAction.elements_involved.append(val1)
      start = end
      end += 1
      (self.emitYaml,) = _get_struct_B().unpack(str[start:end])
      self.emitYaml = bool(self.emitYaml)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.newAction.action_name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.newAction.action_motor_position.name)
      buff.write(_struct_I.pack(length))
      for val1 in self.newAction.action_motor_position.name:
        length = len(val1)
        if python3 or type(val1) == unicode:
          val1 = val1.encode('utf-8')
          length = len(val1)
        buff.write(struct.Struct('<I%ss'%length).pack(length, val1))
      length = len(self.newAction.action_motor_position.position)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(self.newAction.action_motor_position.position.tostring())
      length = len(self.newAction.action_motor_count.name)
      buff.write(_struct_I.pack(length))
      for val1 in self.newAction.action_motor_count.name:
        length = len(val1)
        if python3 or type(val1) == unicode:
          val1 = val1.encode('utf-8')
          length = len(val1)
        buff.write(struct.Struct('<I%ss'%length).pack(length, val1))
      _x = self.newAction.action_motor_count.count
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.newAction.elements_involved)
      buff.write(_struct_I.pack(length))
      for val1 in self.newAction.elements_involved:
        length = len(val1)
        if python3 or type(val1) == unicode:
          val1 = val1.encode('utf-8')
          length = len(val1)
        buff.write(struct.Struct('<I%ss'%length).pack(length, val1))
      _x = self.emitYaml
      buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.newAction is None:
        self.newAction = rosee_msg.msg.NewGenericGraspingAction()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.newAction.action_name = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.newAction.action_name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.newAction.action_motor_position.name = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1 = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1 = str[start:end]
        self.newAction.action_motor_position.name.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.newAction.action_motor_position.position = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.newAction.action_motor_count.name = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1 = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1 = str[start:end]
        self.newAction.action_motor_count.name.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.newAction.action_motor_count.count = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.newAction.elements_involved = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1 = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1 = str[start:end]
        self.newAction.elements_involved.append(val1)
      start = end
      end += 1
      (self.emitYaml,) = _get_struct_B().unpack(str[start:end])
      self.emitYaml = bool(self.emitYaml)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from rosee_msg/NewGenericGraspingActionSrvResponse.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class NewGenericGraspingActionSrvResponse(genpy.Message):
  _md5sum = "07a4c65769c1bf305a41a83f2f9eb211"
  _type = "rosee_msg/NewGenericGraspingActionSrvResponse"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """
# the service will give true if action is good and it is inserted in the structure
bool accepted

# true false depending if emission on yaml file is successful
bool emitted

# string containing useful info about a possible not acceptance
string error_msg

"""
  __slots__ = ['accepted','emitted','error_msg']
  _slot_types = ['bool','bool','string']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       accepted,emitted,error_msg

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(NewGenericGraspingActionSrvResponse, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.accepted is None:
        self.accepted = False
      if self.emitted is None:
        self.emitted = False
      if self.error_msg is None:
        self.error_msg = ''
    else:
      self.accepted = False
      self.emitted = False
      self.error_msg = ''

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_2B().pack(_x.accepted, _x.emitted))
      _x = self.error_msg
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 2
      (_x.accepted, _x.emitted,) = _get_struct_2B().unpack(str[start:end])
      self.accepted = bool(self.accepted)
      self.emitted = bool(self.emitted)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.error_msg = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.error_msg = str[start:end]
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_2B().pack(_x.accepted, _x.emitted))
      _x = self.error_msg
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 2
      (_x.accepted, _x.emitted,) = _get_struct_2B().unpack(str[start:end])
      self.accepted = bool(self.accepted)
      self.emitted = bool(self.emitted)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.error_msg = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.error_msg = str[start:end]
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2B = None
def _get_struct_2B():
    global _struct_2B
    if _struct_2B is None:
        _struct_2B = struct.Struct("<2B")
    return _struct_2B
class NewGenericGraspingActionSrv(object):
  _type          = 'rosee_msg/NewGenericGraspingActionSrv'
  _md5sum = '791b81fd4353d7406ebecb6484da4d56'
  _request_class  = NewGenericGraspingActionSrvRequest
  _response_class = NewGenericGraspingActionSrvResponse
