// Auto-generated. Do not edit!

// (in-package rosee_msg.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let MotorPosition = require('./MotorPosition.js');
let JointsInvolvedCount = require('./JointsInvolvedCount.js');

//-----------------------------------------------------------

class NewGenericGraspingAction {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.action_name = null;
      this.action_motor_position = null;
      this.action_motor_count = null;
      this.elements_involved = null;
    }
    else {
      if (initObj.hasOwnProperty('action_name')) {
        this.action_name = initObj.action_name
      }
      else {
        this.action_name = '';
      }
      if (initObj.hasOwnProperty('action_motor_position')) {
        this.action_motor_position = initObj.action_motor_position
      }
      else {
        this.action_motor_position = new MotorPosition();
      }
      if (initObj.hasOwnProperty('action_motor_count')) {
        this.action_motor_count = initObj.action_motor_count
      }
      else {
        this.action_motor_count = new JointsInvolvedCount();
      }
      if (initObj.hasOwnProperty('elements_involved')) {
        this.elements_involved = initObj.elements_involved
      }
      else {
        this.elements_involved = [];
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type NewGenericGraspingAction
    // Serialize message field [action_name]
    bufferOffset = _serializer.string(obj.action_name, buffer, bufferOffset);
    // Serialize message field [action_motor_position]
    bufferOffset = MotorPosition.serialize(obj.action_motor_position, buffer, bufferOffset);
    // Serialize message field [action_motor_count]
    bufferOffset = JointsInvolvedCount.serialize(obj.action_motor_count, buffer, bufferOffset);
    // Serialize message field [elements_involved]
    bufferOffset = _arraySerializer.string(obj.elements_involved, buffer, bufferOffset, null);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type NewGenericGraspingAction
    let len;
    let data = new NewGenericGraspingAction(null);
    // Deserialize message field [action_name]
    data.action_name = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [action_motor_position]
    data.action_motor_position = MotorPosition.deserialize(buffer, bufferOffset);
    // Deserialize message field [action_motor_count]
    data.action_motor_count = JointsInvolvedCount.deserialize(buffer, bufferOffset);
    // Deserialize message field [elements_involved]
    data.elements_involved = _arrayDeserializer.string(buffer, bufferOffset, null)
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += _getByteLength(object.action_name);
    length += MotorPosition.getMessageSize(object.action_motor_position);
    length += JointsInvolvedCount.getMessageSize(object.action_motor_count);
    object.elements_involved.forEach((val) => {
      length += 4 + _getByteLength(val);
    });
    return length + 8;
  }

  static datatype() {
    // Returns string type for a message object
    return 'rosee_msg/NewGenericGraspingAction';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '1b5b47369928988fdc6ad9e59fd3ea8f';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # Message which include all the infos necessary to insert a new action in the system 
    # (https://github.com/ADVRHumanoids/ROSEndEffector/issues/71)
    
    # name of the action
    string action_name
    
    # Motor Position
    MotorPosition action_motor_position
    
    # OPTIONAL The mask which says if the motor is used by the action (count > 0) or not (count = 0).
    # take care that if it is not included, the not used joint will be considered the ones with 0 position
    JointsInvolvedCount action_motor_count
                                      
    # OPTIONAL field to indicate which hand element will be moved by the action
    string[] elements_involved
    
    ================================================================================
    MSG: rosee_msg/MotorPosition
    # I do not want to use standard joint state because also velocity and effort are present, which are not used by an action
    
    # All arrays in this message should have the same size, or be empty.
    # This is the only way to uniquely associate the joint name with the correct
    # states.
    
    string[] name
    float64[] position
    
    ================================================================================
    MSG: rosee_msg/JointsInvolvedCount
    # This is the msg for the type 
    #    "typedef std::map <std::string, unsigned int> JointsInvolvedCount"
    
    
    # All arrays in this message should have the same size, or be empty.
    # This is the only way to uniquely associate the joint name with the correct
    # states. 
    
    string[] name
    uint8[] count
    
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new NewGenericGraspingAction(null);
    if (msg.action_name !== undefined) {
      resolved.action_name = msg.action_name;
    }
    else {
      resolved.action_name = ''
    }

    if (msg.action_motor_position !== undefined) {
      resolved.action_motor_position = MotorPosition.Resolve(msg.action_motor_position)
    }
    else {
      resolved.action_motor_position = new MotorPosition()
    }

    if (msg.action_motor_count !== undefined) {
      resolved.action_motor_count = JointsInvolvedCount.Resolve(msg.action_motor_count)
    }
    else {
      resolved.action_motor_count = new JointsInvolvedCount()
    }

    if (msg.elements_involved !== undefined) {
      resolved.elements_involved = msg.elements_involved;
    }
    else {
      resolved.elements_involved = []
    }

    return resolved;
    }
};

module.exports = NewGenericGraspingAction;
