// Auto-generated. Do not edit!

// (in-package rosee_msg.srv)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let std_msgs = _finder('std_msgs');

//-----------------------------------------------------------


//-----------------------------------------------------------

class HandInfoRequest {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.motor_positions = null;
      this.motor_positions_reference = null;
      this.finger_joint_positions = null;
    }
    else {
      if (initObj.hasOwnProperty('motor_positions')) {
        this.motor_positions = initObj.motor_positions
      }
      else {
        this.motor_positions = [];
      }
      if (initObj.hasOwnProperty('motor_positions_reference')) {
        this.motor_positions_reference = initObj.motor_positions_reference
      }
      else {
        this.motor_positions_reference = [];
      }
      if (initObj.hasOwnProperty('finger_joint_positions')) {
        this.finger_joint_positions = initObj.finger_joint_positions
      }
      else {
        this.finger_joint_positions = new std_msgs.msg.Float32MultiArray();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type HandInfoRequest
    // Serialize message field [motor_positions]
    bufferOffset = _arraySerializer.float32(obj.motor_positions, buffer, bufferOffset, null);
    // Serialize message field [motor_positions_reference]
    bufferOffset = _arraySerializer.float32(obj.motor_positions_reference, buffer, bufferOffset, null);
    // Serialize message field [finger_joint_positions]
    bufferOffset = std_msgs.msg.Float32MultiArray.serialize(obj.finger_joint_positions, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type HandInfoRequest
    let len;
    let data = new HandInfoRequest(null);
    // Deserialize message field [motor_positions]
    data.motor_positions = _arrayDeserializer.float32(buffer, bufferOffset, null)
    // Deserialize message field [motor_positions_reference]
    data.motor_positions_reference = _arrayDeserializer.float32(buffer, bufferOffset, null)
    // Deserialize message field [finger_joint_positions]
    data.finger_joint_positions = std_msgs.msg.Float32MultiArray.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += 4 * object.motor_positions.length;
    length += 4 * object.motor_positions_reference.length;
    length += std_msgs.msg.Float32MultiArray.getMessageSize(object.finger_joint_positions);
    return length + 8;
  }

  static datatype() {
    // Returns string type for a service object
    return 'rosee_msg/HandInfoRequest';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'b2db53cde8466585098f8e25b12e4146';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    ## Service msg for all the info needed by ROSEE Grasp Planner
    
    # Providing this info is necessary for heri Hal so it knows for which pose it should compute the reqeusted matrices
    
    float32[] motor_positions
    float32[] motor_positions_reference
    std_msgs/Float32MultiArray finger_joint_positions #in a finger, the phalange joints order must be from the base finger to the tip
    
    
    ================================================================================
    MSG: std_msgs/Float32MultiArray
    # Please look at the MultiArrayLayout message definition for
    # documentation on all multiarrays.
    
    MultiArrayLayout  layout        # specification of data layout
    float32[]         data          # array of data
    
    
    ================================================================================
    MSG: std_msgs/MultiArrayLayout
    # The multiarray declares a generic multi-dimensional array of a
    # particular data type.  Dimensions are ordered from outer most
    # to inner most.
    
    MultiArrayDimension[] dim # Array of dimension properties
    uint32 data_offset        # padding elements at front of data
    
    # Accessors should ALWAYS be written in terms of dimension stride
    # and specified outer-most dimension first.
    # 
    # multiarray(i,j,k) = data[data_offset + dim_stride[1]*i + dim_stride[2]*j + k]
    #
    # A standard, 3-channel 640x480 image with interleaved color channels
    # would be specified as:
    #
    # dim[0].label  = "height"
    # dim[0].size   = 480
    # dim[0].stride = 3*640*480 = 921600  (note dim[0] stride is just size of image)
    # dim[1].label  = "width"
    # dim[1].size   = 640
    # dim[1].stride = 3*640 = 1920
    # dim[2].label  = "channel"
    # dim[2].size   = 3
    # dim[2].stride = 3
    #
    # multiarray(i,j,k) refers to the ith row, jth column, and kth channel.
    
    ================================================================================
    MSG: std_msgs/MultiArrayDimension
    string label   # label of given dimension
    uint32 size    # size of given dimension (in type units)
    uint32 stride  # stride of given dimension
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new HandInfoRequest(null);
    if (msg.motor_positions !== undefined) {
      resolved.motor_positions = msg.motor_positions;
    }
    else {
      resolved.motor_positions = []
    }

    if (msg.motor_positions_reference !== undefined) {
      resolved.motor_positions_reference = msg.motor_positions_reference;
    }
    else {
      resolved.motor_positions_reference = []
    }

    if (msg.finger_joint_positions !== undefined) {
      resolved.finger_joint_positions = std_msgs.msg.Float32MultiArray.Resolve(msg.finger_joint_positions)
    }
    else {
      resolved.finger_joint_positions = new std_msgs.msg.Float32MultiArray()
    }

    return resolved;
    }
};

class HandInfoResponse {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.fingers_names = null;
      this.motors_names = null;
      this.transmission_matrix = null;
      this.transmission_square_matrices = null;
      this.transmission_augmented_matrices = null;
      this.tips_jacobians_normal = null;
      this.tips_jacobians_friction = null;
      this.tips_forces_normal = null;
      this.tips_forces_friction = null;
      this.motors_stiffness = null;
      this.tips_frictions = null;
      this.motors_torque_limits = null;
    }
    else {
      if (initObj.hasOwnProperty('fingers_names')) {
        this.fingers_names = initObj.fingers_names
      }
      else {
        this.fingers_names = [];
      }
      if (initObj.hasOwnProperty('motors_names')) {
        this.motors_names = initObj.motors_names
      }
      else {
        this.motors_names = [];
      }
      if (initObj.hasOwnProperty('transmission_matrix')) {
        this.transmission_matrix = initObj.transmission_matrix
      }
      else {
        this.transmission_matrix = new std_msgs.msg.Float32MultiArray();
      }
      if (initObj.hasOwnProperty('transmission_square_matrices')) {
        this.transmission_square_matrices = initObj.transmission_square_matrices
      }
      else {
        this.transmission_square_matrices = [];
      }
      if (initObj.hasOwnProperty('transmission_augmented_matrices')) {
        this.transmission_augmented_matrices = initObj.transmission_augmented_matrices
      }
      else {
        this.transmission_augmented_matrices = [];
      }
      if (initObj.hasOwnProperty('tips_jacobians_normal')) {
        this.tips_jacobians_normal = initObj.tips_jacobians_normal
      }
      else {
        this.tips_jacobians_normal = [];
      }
      if (initObj.hasOwnProperty('tips_jacobians_friction')) {
        this.tips_jacobians_friction = initObj.tips_jacobians_friction
      }
      else {
        this.tips_jacobians_friction = [];
      }
      if (initObj.hasOwnProperty('tips_forces_normal')) {
        this.tips_forces_normal = initObj.tips_forces_normal
      }
      else {
        this.tips_forces_normal = [];
      }
      if (initObj.hasOwnProperty('tips_forces_friction')) {
        this.tips_forces_friction = initObj.tips_forces_friction
      }
      else {
        this.tips_forces_friction = [];
      }
      if (initObj.hasOwnProperty('motors_stiffness')) {
        this.motors_stiffness = initObj.motors_stiffness
      }
      else {
        this.motors_stiffness = [];
      }
      if (initObj.hasOwnProperty('tips_frictions')) {
        this.tips_frictions = initObj.tips_frictions
      }
      else {
        this.tips_frictions = [];
      }
      if (initObj.hasOwnProperty('motors_torque_limits')) {
        this.motors_torque_limits = initObj.motors_torque_limits
      }
      else {
        this.motors_torque_limits = [];
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type HandInfoResponse
    // Serialize message field [fingers_names]
    bufferOffset = _arraySerializer.string(obj.fingers_names, buffer, bufferOffset, null);
    // Serialize message field [motors_names]
    bufferOffset = _arraySerializer.string(obj.motors_names, buffer, bufferOffset, null);
    // Serialize message field [transmission_matrix]
    bufferOffset = std_msgs.msg.Float32MultiArray.serialize(obj.transmission_matrix, buffer, bufferOffset);
    // Serialize message field [transmission_square_matrices]
    // Serialize the length for message field [transmission_square_matrices]
    bufferOffset = _serializer.uint32(obj.transmission_square_matrices.length, buffer, bufferOffset);
    obj.transmission_square_matrices.forEach((val) => {
      bufferOffset = std_msgs.msg.Float32MultiArray.serialize(val, buffer, bufferOffset);
    });
    // Serialize message field [transmission_augmented_matrices]
    // Serialize the length for message field [transmission_augmented_matrices]
    bufferOffset = _serializer.uint32(obj.transmission_augmented_matrices.length, buffer, bufferOffset);
    obj.transmission_augmented_matrices.forEach((val) => {
      bufferOffset = std_msgs.msg.Float32MultiArray.serialize(val, buffer, bufferOffset);
    });
    // Serialize message field [tips_jacobians_normal]
    // Serialize the length for message field [tips_jacobians_normal]
    bufferOffset = _serializer.uint32(obj.tips_jacobians_normal.length, buffer, bufferOffset);
    obj.tips_jacobians_normal.forEach((val) => {
      bufferOffset = std_msgs.msg.Float32MultiArray.serialize(val, buffer, bufferOffset);
    });
    // Serialize message field [tips_jacobians_friction]
    // Serialize the length for message field [tips_jacobians_friction]
    bufferOffset = _serializer.uint32(obj.tips_jacobians_friction.length, buffer, bufferOffset);
    obj.tips_jacobians_friction.forEach((val) => {
      bufferOffset = std_msgs.msg.Float32MultiArray.serialize(val, buffer, bufferOffset);
    });
    // Serialize message field [tips_forces_normal]
    bufferOffset = _arraySerializer.float32(obj.tips_forces_normal, buffer, bufferOffset, null);
    // Serialize message field [tips_forces_friction]
    bufferOffset = _arraySerializer.float32(obj.tips_forces_friction, buffer, bufferOffset, null);
    // Serialize message field [motors_stiffness]
    bufferOffset = _arraySerializer.float32(obj.motors_stiffness, buffer, bufferOffset, null);
    // Serialize message field [tips_frictions]
    bufferOffset = _arraySerializer.float32(obj.tips_frictions, buffer, bufferOffset, null);
    // Serialize message field [motors_torque_limits]
    bufferOffset = _arraySerializer.float32(obj.motors_torque_limits, buffer, bufferOffset, null);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type HandInfoResponse
    let len;
    let data = new HandInfoResponse(null);
    // Deserialize message field [fingers_names]
    data.fingers_names = _arrayDeserializer.string(buffer, bufferOffset, null)
    // Deserialize message field [motors_names]
    data.motors_names = _arrayDeserializer.string(buffer, bufferOffset, null)
    // Deserialize message field [transmission_matrix]
    data.transmission_matrix = std_msgs.msg.Float32MultiArray.deserialize(buffer, bufferOffset);
    // Deserialize message field [transmission_square_matrices]
    // Deserialize array length for message field [transmission_square_matrices]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.transmission_square_matrices = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.transmission_square_matrices[i] = std_msgs.msg.Float32MultiArray.deserialize(buffer, bufferOffset)
    }
    // Deserialize message field [transmission_augmented_matrices]
    // Deserialize array length for message field [transmission_augmented_matrices]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.transmission_augmented_matrices = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.transmission_augmented_matrices[i] = std_msgs.msg.Float32MultiArray.deserialize(buffer, bufferOffset)
    }
    // Deserialize message field [tips_jacobians_normal]
    // Deserialize array length for message field [tips_jacobians_normal]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.tips_jacobians_normal = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.tips_jacobians_normal[i] = std_msgs.msg.Float32MultiArray.deserialize(buffer, bufferOffset)
    }
    // Deserialize message field [tips_jacobians_friction]
    // Deserialize array length for message field [tips_jacobians_friction]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.tips_jacobians_friction = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.tips_jacobians_friction[i] = std_msgs.msg.Float32MultiArray.deserialize(buffer, bufferOffset)
    }
    // Deserialize message field [tips_forces_normal]
    data.tips_forces_normal = _arrayDeserializer.float32(buffer, bufferOffset, null)
    // Deserialize message field [tips_forces_friction]
    data.tips_forces_friction = _arrayDeserializer.float32(buffer, bufferOffset, null)
    // Deserialize message field [motors_stiffness]
    data.motors_stiffness = _arrayDeserializer.float32(buffer, bufferOffset, null)
    // Deserialize message field [tips_frictions]
    data.tips_frictions = _arrayDeserializer.float32(buffer, bufferOffset, null)
    // Deserialize message field [motors_torque_limits]
    data.motors_torque_limits = _arrayDeserializer.float32(buffer, bufferOffset, null)
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    object.fingers_names.forEach((val) => {
      length += 4 + _getByteLength(val);
    });
    object.motors_names.forEach((val) => {
      length += 4 + _getByteLength(val);
    });
    length += std_msgs.msg.Float32MultiArray.getMessageSize(object.transmission_matrix);
    object.transmission_square_matrices.forEach((val) => {
      length += std_msgs.msg.Float32MultiArray.getMessageSize(val);
    });
    object.transmission_augmented_matrices.forEach((val) => {
      length += std_msgs.msg.Float32MultiArray.getMessageSize(val);
    });
    object.tips_jacobians_normal.forEach((val) => {
      length += std_msgs.msg.Float32MultiArray.getMessageSize(val);
    });
    object.tips_jacobians_friction.forEach((val) => {
      length += std_msgs.msg.Float32MultiArray.getMessageSize(val);
    });
    length += 4 * object.tips_forces_normal.length;
    length += 4 * object.tips_forces_friction.length;
    length += 4 * object.motors_stiffness.length;
    length += 4 * object.tips_frictions.length;
    length += 4 * object.motors_torque_limits.length;
    return length + 44;
  }

  static datatype() {
    // Returns string type for a service object
    return 'rosee_msg/HandInfoResponse';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'c3111b62b7be478c06ead15559030d6a';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    
    #all the subsequent info will follow the order specified in motors_names and fingertips_names
    string[] fingers_names
    string[] motors_names
    
    std_msgs/Float32MultiArray transmission_matrix
    
    std_msgs/Float32MultiArray[] transmission_square_matrices
    
    # The matrices introduces because motor is not the first finger joint,
    # computed as transmission_square_matrice ^-T * T*
    std_msgs/Float32MultiArray[] transmission_augmented_matrices
    
    
    std_msgs/Float32MultiArray[] tips_jacobians_normal 
    std_msgs/Float32MultiArray[] tips_jacobians_friction
    #note: third componet of force is trascurable
    
    float32[] tips_forces_normal
    float32[] tips_forces_friction
    #note: third componet of force is trascurable
    
    float32[] motors_stiffness
    float32[] tips_frictions
    float32[] motors_torque_limits
    
    
    ================================================================================
    MSG: std_msgs/Float32MultiArray
    # Please look at the MultiArrayLayout message definition for
    # documentation on all multiarrays.
    
    MultiArrayLayout  layout        # specification of data layout
    float32[]         data          # array of data
    
    
    ================================================================================
    MSG: std_msgs/MultiArrayLayout
    # The multiarray declares a generic multi-dimensional array of a
    # particular data type.  Dimensions are ordered from outer most
    # to inner most.
    
    MultiArrayDimension[] dim # Array of dimension properties
    uint32 data_offset        # padding elements at front of data
    
    # Accessors should ALWAYS be written in terms of dimension stride
    # and specified outer-most dimension first.
    # 
    # multiarray(i,j,k) = data[data_offset + dim_stride[1]*i + dim_stride[2]*j + k]
    #
    # A standard, 3-channel 640x480 image with interleaved color channels
    # would be specified as:
    #
    # dim[0].label  = "height"
    # dim[0].size   = 480
    # dim[0].stride = 3*640*480 = 921600  (note dim[0] stride is just size of image)
    # dim[1].label  = "width"
    # dim[1].size   = 640
    # dim[1].stride = 3*640 = 1920
    # dim[2].label  = "channel"
    # dim[2].size   = 3
    # dim[2].stride = 3
    #
    # multiarray(i,j,k) refers to the ith row, jth column, and kth channel.
    
    ================================================================================
    MSG: std_msgs/MultiArrayDimension
    string label   # label of given dimension
    uint32 size    # size of given dimension (in type units)
    uint32 stride  # stride of given dimension
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new HandInfoResponse(null);
    if (msg.fingers_names !== undefined) {
      resolved.fingers_names = msg.fingers_names;
    }
    else {
      resolved.fingers_names = []
    }

    if (msg.motors_names !== undefined) {
      resolved.motors_names = msg.motors_names;
    }
    else {
      resolved.motors_names = []
    }

    if (msg.transmission_matrix !== undefined) {
      resolved.transmission_matrix = std_msgs.msg.Float32MultiArray.Resolve(msg.transmission_matrix)
    }
    else {
      resolved.transmission_matrix = new std_msgs.msg.Float32MultiArray()
    }

    if (msg.transmission_square_matrices !== undefined) {
      resolved.transmission_square_matrices = new Array(msg.transmission_square_matrices.length);
      for (let i = 0; i < resolved.transmission_square_matrices.length; ++i) {
        resolved.transmission_square_matrices[i] = std_msgs.msg.Float32MultiArray.Resolve(msg.transmission_square_matrices[i]);
      }
    }
    else {
      resolved.transmission_square_matrices = []
    }

    if (msg.transmission_augmented_matrices !== undefined) {
      resolved.transmission_augmented_matrices = new Array(msg.transmission_augmented_matrices.length);
      for (let i = 0; i < resolved.transmission_augmented_matrices.length; ++i) {
        resolved.transmission_augmented_matrices[i] = std_msgs.msg.Float32MultiArray.Resolve(msg.transmission_augmented_matrices[i]);
      }
    }
    else {
      resolved.transmission_augmented_matrices = []
    }

    if (msg.tips_jacobians_normal !== undefined) {
      resolved.tips_jacobians_normal = new Array(msg.tips_jacobians_normal.length);
      for (let i = 0; i < resolved.tips_jacobians_normal.length; ++i) {
        resolved.tips_jacobians_normal[i] = std_msgs.msg.Float32MultiArray.Resolve(msg.tips_jacobians_normal[i]);
      }
    }
    else {
      resolved.tips_jacobians_normal = []
    }

    if (msg.tips_jacobians_friction !== undefined) {
      resolved.tips_jacobians_friction = new Array(msg.tips_jacobians_friction.length);
      for (let i = 0; i < resolved.tips_jacobians_friction.length; ++i) {
        resolved.tips_jacobians_friction[i] = std_msgs.msg.Float32MultiArray.Resolve(msg.tips_jacobians_friction[i]);
      }
    }
    else {
      resolved.tips_jacobians_friction = []
    }

    if (msg.tips_forces_normal !== undefined) {
      resolved.tips_forces_normal = msg.tips_forces_normal;
    }
    else {
      resolved.tips_forces_normal = []
    }

    if (msg.tips_forces_friction !== undefined) {
      resolved.tips_forces_friction = msg.tips_forces_friction;
    }
    else {
      resolved.tips_forces_friction = []
    }

    if (msg.motors_stiffness !== undefined) {
      resolved.motors_stiffness = msg.motors_stiffness;
    }
    else {
      resolved.motors_stiffness = []
    }

    if (msg.tips_frictions !== undefined) {
      resolved.tips_frictions = msg.tips_frictions;
    }
    else {
      resolved.tips_frictions = []
    }

    if (msg.motors_torque_limits !== undefined) {
      resolved.motors_torque_limits = msg.motors_torque_limits;
    }
    else {
      resolved.motors_torque_limits = []
    }

    return resolved;
    }
};

module.exports = {
  Request: HandInfoRequest,
  Response: HandInfoResponse,
  md5sum() { return 'ecb8bd1182371c883c9160af4ed8a590'; },
  datatype() { return 'rosee_msg/HandInfo'; }
};
